<template>
  <!-- PAGINATION -->
  <nav class="col-12 mt-5" aria-label="Page navigation">
    <ul class="pagination justify-content-center">
      <li class="page-item" v-if="activeStep !== 1">
        <button id="previousButton" class="btn page-link" :class="{ 'disabled': activeStep === 1 }" @click="previous()">
          {{ activeStep === 4 ? 'Go to Catalogue Page' : $t('message.pagination.previousPage') }}
        </button>
      </li>
      <li class="page-item" v-if="showNextButton">
        <button id="nextButton" class="btn bg-primary text-light page-link" @click="next()">
          {{ activeStep === 4 ? 'Go to Dataset Page' : $t('message.pagination.nextPage') }}
        </button>
      </li>
    </ul>
  </nav>
</template>

<script>
  import { mapActions, mapGetters } from 'vuex';

  export default {
    name: 'EDP2-uploadPage-bottom',
    components: {},
    data() {
      return {};
    },
    props: {
      activeStep: {
        type: Number,
        default: 1,
      },
    },
    computed: {
      ...mapGetters('upload', [
        'getValidate',
        'getID',
        'getCatalogue',
        'getDistributions',
        'getAPIUploadData',
      ]),
      query() {
        if (typeof this.$route.query.catalog === 'string') return { catalog: this.$route.query.catalog, showcataloguedetails: 'true', locale: this.$route.query.locale };
        return { locale: this.$route.query.locale };
      },
      showNextButton() {
        if (this.activeStep === 1) return true;
        if (this.activeStep === 2) return this.getDistributions.length > 0;
        if (this.activeStep === 3) return !this.getAPIUploadData.distributions.some(distribution => distribution.file.uploadSuccess === false);
        if (this.activeStep === 4) return true;
        return false;
      },
    },
    methods: {
      ...mapActions('upload', [
        'setStep',
        'setValidate',
      ]),
      previous() {
        switch (this.activeStep) {
        case null:
          this.setStep(1);
          this.$router.push({ name: 'UploadPageDatasetDetails', query: this.query, params: this.$route.params });
          break;
        case 1:
          // Disabled
          break;
        case 2:
          // Back to Dataset Details
          this.setStep(1);
          this.$router.push({ name: 'UploadPageDatasetDetails', query: this.query, params: this.$route.params });
          break;
        case 3:
          // Check if Files have been uploaded already
          this.setStep(2);
          this.$router.push({ name: 'UploadPageDistributions', query: this.query, params: this.$route.params });
          break;
        case 4:
          // Finish Data Upload
          this.setValidate(true);
          this.$router.push({ name: 'Datasets', query: { catalog: this.getCatalogue, showcataloguedetails: 'true', locale: this.$route.query.locale } });
          break;
        default:
          this.setStep(1);
          this.$router.push({ name: 'UploadPageDatasetDetails', query: this.query, params: this.$route.params });
        }
      },
      next() {
        switch (this.activeStep) {
        case null:
          this.setStep(1);
          this.$router.push({ name: 'UploadPageDatasetDetails', query: this.query, params: this.$route.params });
          break;
        case 1:
          // Trigger Dataset Details Validation
          this.setValidate(true);
          break;
        case 2:
          // Trigger Distributions Validation
          this.setValidate(true);
          break;
        case 3:
          // Trigger File Upload Validation
          this.setValidate(true);
          break;
        case 4:
          // Finish Data Upload
          this.setValidate(true);
          this.$router.push({ path: `/datasets/${this.getID}`, query: { locale: this.$route.query.locale } });
          break;
        default:
          this.setStep(1);
          this.$router.push({ name: 'UploadPageDatasetDetails', query: this.query, params: this.$route.params });
        }
      },
    },
    watch: {},
  };
</script>

<style scoped lang='scss'>
  .heading, .arrow {
    cursor: pointer;
  }
</style>
